function [pvalues pv zscore edge]=wsr(matrix,graph_filename,label)

%matrix=merge_matrices(mat);

[A B]=size(matrix);
pvalues=zeros(B);
zscore=zeros(B);
for i=1:B
    for j=1:B
        [pvalues(i,j) bla stats]=signrank2(matrix(:,i),matrix(:,j));
        if isfield(stats,'zval')
            zscore(i,j)=stats.zval;
        end        
    end
end

score=sign(zscore);
pv=pvalues.*score;
% keep interesting pval
t= true(B);
idx=logical(tril(t)-diag(diag(t)));
pvalues=pvalues(idx);
pvalues=mafdr(pvalues,'BHFDR', true);

newpval=zeros(B);
k=0;
    
for j=1:B-1
    for i=j+1:B    
        k=k+1;
       newpval(i,j)=pvalues(k);
    end
end

newpval=newpval.*score;

edge=false(B);

for j=1:B-1;
    for i=j+1:B
        if abs(newpval(i,j))<0.05
            if newpval(i,j)>0
                edge(i,j)=true;
            else
                edge(j,i)=true;
            end
        end
    end
end

fprintf('Found %i edges \n',sum(sum(edge))); 

% Check transitivity

  num_deleted = 0;
  for i=1:B
    for j=1:B
      for k=1:B
        if edge(i,j) && edge(j,k) && edge (i,k)
          edge(i,k) = false;
          num_deleted =num_deleted+1;
        end
      end
    end
  end
fprintf('Deleted %i edges \n',num_deleted); 

mean_value=median(matrix);

graph_file = fopen([graph_filename,'.gwz.dot'], 'w');
 fprintf(graph_file,'digraph G {\n');
  for id=1:B
    name=label{id};  
    fprintf(graph_file,'"%s" [label="%s%s%.3f"];\n',name, label{id},'\n', mean_value(id));
  end
 
  for i=1:B
    for j=1:B
      if edge(i,j)
          id1=label{i};
          id2=label{j};
        fprintf(graph_file,'"%s" -> "%s";\n',id1,id2);
      end
    end
  end
  fprintf(graph_file,'}');
  fclose(graph_file); 
